#ifndef DELEGATE_H
#define DELEGATE_H
#include <QItemDelegate>
#include <QModelIndex>
#include <QSqlQuery>
#include <QObject>
#include <QSize>
#include <QSpinBox>
#include <QMap>
#include <QTableView>

#include "iconform.h"

//! [0]
class SpinBoxDelegate : public QItemDelegate
{
    Q_OBJECT

public:
    SpinBoxDelegate(QObject *parent = 0);

    QWidget *createEditor(QWidget *parent, const QStyleOptionViewItem &option,
                          const QModelIndex &index) const;

    void setEditorData(QWidget *editor, const QModelIndex &index) const;
    void setModelData(QWidget *editor, QAbstractItemModel *model,
                      const QModelIndex &index) const;

    void updateEditorGeometry(QWidget *editor,
        const QStyleOptionViewItem &option, const QModelIndex &index) const;

    void getItems(); //   

private:
     QMap <QString, QString> items; //           ID


};
//! [0]

class MyDEDelegate : public QItemDelegate {
       Q_OBJECT
   public:
       MyDEDelegate(bool calpopup = true,
                    QObject *parent = 0);
       QWidget *createEditor(
                   QWidget *parent,
                   const QStyleOptionViewItem &option,
                   const QModelIndex &index) const;
       void setEditorData(QWidget *editor,
                          const QModelIndex &index) const;
       void setModelData(QWidget *editor,
                         QAbstractItemModel *model,
                         const QModelIndex &index) const;
      void updateEditorGeometry(
              QWidget *editor,
              const QStyleOptionViewItem &option,
              const QModelIndex &index) const;
   private:
        bool m_calpopup;
    };


class CPictureDelegate : public QItemDelegate
{
    mutable QPixmap m_pxPicture;
private:
        QTableView *tblView;

public:
         CPictureDelegate( QObject *parent );

         QWidget *createEditor(
                     QWidget *parent,
                     const QStyleOptionViewItem &option,
                     const QModelIndex &index) const;

         void setEditorData(QWidget *editor,
                            const QModelIndex &index) const;

         void setModelData(QWidget *editor,
                           QAbstractItemModel *model,
                           const QModelIndex &index) const;


         void updateEditorGeometry(
                 QWidget *editor,
                 const QStyleOptionViewItem &option,
                 const QModelIndex &index) const;

         void paint(QPainter *painter, const QStyleOptionViewItem &option,
                                const QModelIndex &index) const;

        void setTableView(QTableView* table);


         //QSize sizeHint(const QStyleOptionViewItem &option, const QModelIndex &index) const;
};




#endif // DELEGATE_H
